states[S_SPECCYEMBLEM] = {
	sprite = SPR_SEMB,
	frame = N,
	tics = -1,
	nextstate = S_NULL
}

mobjinfo[MT_SPECCYEMBLEM] = {
	spawnstate = S_SPECCYEMBLEM,
	deathstate = S_SPRK1,
	radius = 8*FRACUNIT,
	height = 16*FRACUNIT,
	mass = 4,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

addHook("MapLoad", function()
	if (not modifiedgame) or netgame then return end
	for emb in mapthings.iterate do
		if emb.type == mobjinfo[MT_EMBLEM].doomednum then
			local semb = P_SpawnMobj(emb.x*FRACUNIT, emb.y*FRACUNIT, 0, MT_SPECCYEMBLEM)
			semb.sembz = emb.z
			semb.color = SKINCOLOR_SPECCY
			semb.id = emb.angle
			if G_IsSpecialStage(gamemap) then semb.fakering = P_SpawnMobj(semb.x, semb.y, semb.z, MT_RING) semb.fakering.flags2 = $|MF2_DONTDRAW semb.fakering.issemb = true end
		end
	end
end)

rawset(_G, "speccyEmblems", {
	[0] = {A, SKINCOLOR_BLUE},
	[1] = {B, SKINCOLOR_PURPLE},
	[2] = {C, SKINCOLOR_RED},
	[3] = {D, SKINCOLOR_ORANGE},
	[4] = {E, SKINCOLOR_GREEN},
	["sonic"] = {U, SKINCOLOR_BLUE},
	["tails"] = {V, SKINCOLOR_ORANGE},
	["knuckles"] = {W, SKINCOLOR_RED},
	["metal"] = {X, SKINCOLOR_COBALT},
	["fang"] = {Y, SKINCOLOR_PURPLE},
	["amy"] = {Z, SKINCOLOR_ROSY},
	["speccy"] = {N, SKINCOLOR_SPECCY},
	["kotone"] = {O, SKINCOLOR_BROWN}
})

addHook("MobjThinker", function(semb)
	if not semb.valid then return end
	if (not modifiedgame) or netgame then return end
	if semb.sembz != nil then
		semb.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_SPECIAL
		semb.z = semb.floorz+(semb.sembz*FRACUNIT)
		semb.sembz = nil
		if semb.fakering and semb.fakering.valid then
			semb.fakering.z = semb.z
		end
		local frame = A
		local color = SKINCOLOR_BLUE
		if players[0].mo and players[0].mo.valid then 
			if speccyEmblems[players[0].mo.skin] ~= nil then 
				frame = speccyEmblems[players[0].mo.skin][1] 
				color = speccyEmblems[players[0].mo.skin][2]
			end 
		end
		if frame == nil then frame = speccyEmblems[semb.id][1] end
		if color == nil then color = speccyEmblems[semb.id][1] end
		semb.frame = frame|FF_PAPERSPRITE
		semb.color = color
		semb.spriteyoffset = 19*FRACUNIT
	elseif semb.fuse > 1 then
		semb.angle = $+FixedAngle((semb.fuse*FRACUNIT)/4)
		semb.momz = semb.fuse*FRACUNIT/16
		if semb.fakering and semb.fakering.valid then
			P_TeleportMove(semb, semb.fakering.x, semb.fakering.y, semb.fakering.z)
		end
	elseif semb.fuse == 1 then
		semb.fuse = 40
		P_KillMobj(semb)
	else
		semb.angle = $+ANG1
	end
end, MT_SPECCYEMBLEM)

addHook("MobjThinker", function(s)
	if (not modifiedgame) or netgame then return end
	if s.valid
	s.flags = $|MF2_DONTDRAW
	end
end, MT_EMBLEM)

addHook("TouchSpecial", function(semb, s)
	semb.health = 0
	semb.fuse = 45
	S_StartSound(s, sfx_hidden)
	P_AddPlayerScore(s.player, 5000)
	semb.flags = $ & ~MF_SPECIAL
	semb.angle = R_PointToAngle2(semb.x, semb.y, s.x, s.y)
	return true
end, MT_SPECCYEMBLEM)