-- Speccy's abilities.

freeslot(
	"S_NSPECCY_DIVE",
	"S_NSPECCY_SLIDE",
	"S_NSPECCY_CRAWL",
	"SPR2_LOIS",
	"S_NLOIS",
	"S_NSPECCY_SITDOWN",
	"S_NSPECCY_SIT",
	"S_NSPECCY_SIT_TIRED",
	"S_NSPECCY_TWIRL",
	"S_NSPECCY_FIRE_AIR",
	"S_NSPECCY_SWIM_IDLE",
	"S_NSPECCY_SWIM"
)

states[S_NSPECCY_DIVE] = {
	sprite = SPR_PLAY,
	frame = SPR2_FLY_|A,
	tics = -1,
	nextstate = S_NULL
}

states[S_NSPECCY_SLIDE] = {
	sprite = SPR_PLAY,
	frame = SPR2_SPIN|A,
	tics = -1,
	nextstate = S_NULL
}

states[S_NSPECCY_CRAWL] = {
	sprite = SPR_PLAY,
	frame = SPR2_GLID|FF_ANIMATE,
	tics = -1,
	var1 = 3,
	var2 = 7,
	nextstate = S_NULL
}

states[S_NSPECCY_SWIM_IDLE] = {
	sprite = SPR_PLAY,
	frame = SPR2_CLNG|A,
	tics = -1,
	nextstate = S_NULL
}

states[S_NSPECCY_SWIM] = {
	sprite = SPR_PLAY,
	frame = SPR2_SWIM|FF_ANIMATE,
	tics = 12,
	var1 = 2,
	var2 = 4,
	nextstate = S_NSPECCY_SWIM_IDLE
}

states[S_NSPECCY_SITDOWN] = {
	sprite = SPR_PLAY,
	frame = SPR2_MLEE|FF_ANIMATE|A,
	tics = 20,
	var1 = 3,
	var2 = 5,
	nextstate = S_NSPECCY_SIT
}

states[S_NSPECCY_SIT] = {
	sprite = SPR_PLAY,
	frame = SPR2_MLEL|A,
	tics = 105,
	nextstate = S_NSPECCY_SIT_TIRED
}

states[S_NSPECCY_SIT_TIRED] = {
	sprite = SPR_PLAY,
	frame = SPR2_BNCE|FF_ANIMATE|A,
	tics = -1,
	var1 = 1,
	var2 = 17,
	nextstate = S_NULL
}

states[S_NSPECCY_TWIRL] = {
	sprite = SPR_PLAY,
	frame = SPR2_DASH|FF_ANIMATE,
	tics = 8,
	var1 = 3,
	var2 = 2,
	nextstate = S_PLAY_FALL
}

states[S_NSPECCY_FIRE_AIR] = {
	sprite = SPR_PLAY,
	frame = SPR2_FRUN|A,
	tics = -1,
	nextstate = S_PLAY_FALL
}

states[S_NLOIS] = {
	sprite = SPR_PLAY,
	frame = SPR2_LOIS|A,
	tics = -1,
	nextstate = S_NULL
}

local speccycbutton = BT_CUSTOM3
local speccydbutton = BT_USE

local buttons = {BT_USE, BT_CUSTOM1, BT_CUSTOM2, BT_CUSTOM3}

COM_AddCommand("speccy_remap", function(p, arg, arg2)
	if arg == nil or (arg ~= "dive" and arg ~= "crouch") then
		CONS_Printf(p, "speccy_remap:\n - Usage: speccy_remap <move> <button>\n\nMoves:\n - dive: Dive/Roll\n - crouch: Crouch\n\nButtons:\n - 1: Spin\n - 2: Custom 1\n - 3: Custom 2\n - 4: Custom 3")
	else
		if tonumber(arg2) ~= nil then
			arg2 = tonumber(arg2)
			if arg == "dive" then
				speccydbutton = buttons[arg2]
			elseif arg == "crouch" then
				speccycbutton = buttons[arg2]
			end
		else
			CONS_Printf(p, "speccy_remap:\n - Usage: speccy_remap <move> <button>\n\nMoves:\n - dive: Dive/Roll\n - crouch: Crouch\n\nButtons:\n - 1: Spin\n - 2: Custom 1\n - 3: Custom 2\n - 4: Custom 3")
		end
	end
end)

addHook("PlayerSpawn", function(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	p.speccysitdowntimer = 0
	p.speccytwirlcooldown = 0
	p.charflags = $ & ~SF_MARIODAMAGE
end)

addHook("PlayerThink", function(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	if p.speccydeathtimer == nil then 
		p.speccydive = false
		p.speccycrouch = false
		p.speccyroll = false
		p.speccylois = false
		p.speccydiveangle = p.drawangle
		p.speccyjumptimer = 0
		p.speccydeathtimer = 0 
		p.speccysitdowntimer = 0
		p.mo.holdtimer = 0
		p.speccytwirlcooldown = 0
		p.mo.playerdied = false
	end
end)

local function speccyCanCrouch(p)
	if not(p.mo and p.mo.valid) then return false end
	if p.mo.skin ~= "speccy" then return false end
	if p.mo.health < 1 then return end
	if not(p.cmd.buttons & speccycbutton) then return false end
	if not P_IsObjectOnGround(p.mo) then return false end
	if P_PlayerInPain(p) then return false end
	if p.speccyroll then return false end
	if p.fluffymoonwalking then return false end
	if p.speccydive then return false end
	return true
end

local function canSpeccyRoll(p)
	if not(p.mo and p.mo.valid) then return false end
	if p.mo.skin ~= "speccy" then return false end
	if p.mo.health < 1 then return false end
	if (p.speccysamus ~= nil) and (not p.speccysamus.boostball) then return false end
	if p.fluffymoonwalking then return false end
	if p.speccydive then return false end
	if not P_IsObjectOnGround(p.mo) then return false end
	if P_PlayerInPain(p) then return false end
	return true
end

local function canSpeccySuperJump(p)
	if not(p.mo and p.mo.valid) then return false end
	if p.mo.skin ~= "speccy" then return false end
	if p.mo.health < 1 then return false end
	if (p.speccysamus ~= nil) and (not p.speccysamus.hijump) then return false end
	if p.fluffymoonwalking then return false end
	if p.speccydive then return false end
	if not P_IsObjectOnGround(p.mo) then return false end
	if P_PlayerInPain(p) then return false end
	return true
end

local function canSpeccyTwirl(p)
	if not(p.mo and p.mo.valid) then return false end
	if p.mo.skin ~= "speccy" then return false end
	if p.mo.health < 1 then return false end
	if (p.speccysamus ~= nil) and (not p.speccysamus.spacejump) then return false end
	if p.fluffymoonwalking then return false end
	if p.speccydive then return false end
	if P_IsObjectOnGround(p.mo) then return false end
	if P_PlayerInPain(p) then return false end
	return true
end

local function CrouchHeight(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	if p.speccycrouch or p.speccydiving or (p.pflags & PF_SPINNING) then
		p.viewheight = skins[p.mo.skin].height/2
		return skins[p.mo.skin].height/2
	else
		p.viewheight = skins[p.mo.skin].height
		return skins[p.mo.skin].height
	end
end

local function CrouchGap(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	if p.speccycrouch then
		return true
	end
end

addHook("PlayerHeight", CrouchHeight)
addHook("PlayerCanEnterSpinGaps", CrouchGap)

addHook("PlayerThink", function(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.health < 1 then return end
	if p.mo.skin ~= "speccy" then return end
	if p.powers[pw_carry] == CR_NIGHTSMODE then return end
	
	if not (p.cmd.buttons & speccydbutton) then
		p.speccyspinready = true
		p.speccyspintap = false
	elseif p.speccyspinready then
		p.speccyspinready = false
		p.speccyspintap = true
	else
		p.speccyspintap = false
	end
	
	if not (p.cmd.buttons & BT_TOSSFLAG) then
		p.speccyloisready = true
		p.speccyloistap = false
	elseif p.speccyloisready then
		p.speccyloisready = false
		p.speccyloistap = true
	else
		p.speccyloistap = false
	end
	
	if (not (p.cmd.buttons & BT_JUMP)) and (not P_IsObjectOnGround(p.mo)) then
		p.speccyjumpready = true
		p.speccyjumptap = false
	elseif p.speccyjumpready then
		p.speccyjumpready = false
		p.speccyjumptap = true
	else
		p.speccyjumptap = false
	end
	
	if p.speccyloistap then
		if P_RandomRange(1,64) == 1 then
			p.speccylois = true
		end
	end
	
	if p.mo.state == S_PLAY_WAIT then
		if p.speccysitdowntimer >= 10*TICRATE then
			p.mo.state = S_NSPECCY_SITDOWN
		end
		p.speccysitdowntimer = $ + 1 
	else
		p.speccysitdowntimer = 0
	end
	
	if p.mo.state == S_NSPECCY_SITDOWN then
		p.pflags = $|PF_STASIS
	elseif p.mo.state == S_NSPECCY_SIT or p.mo.state == S_NSPECCY_SIT_TIRED then
		p.pflags = $ & ~PF_STASIS
		if p.speed ~= 0 then
			p.mo.state = S_PLAY_STND
		end
	end
	
	if (p.mo.state == S_PLAY_STND or p.mo.state == S_PLAY_WALK or p.mo.state == S_PLAY_RUN) and not P_IsObjectOnGround(p.mo) then
		p.mo.state = S_PLAY_FALL
	end
	
	if speccyCanCrouch(p) then
		p.speccycrouch = true
		p.pflags = $|PF_JUMPSTASIS
		p.normalspeed = 4*FRACUNIT
		if P_IsObjectOnGround(p.mo) and canSpeccySuperJump(p) then
			p.speccyjumptimer = $ + 1
		else
			p.speccyjumptimer = 0
		end
		if p.speccyjumptimer == 35 then 
			S_StartSound(p.mo, sfx_s3ka2, p)
		end
		if p.speccyjumptimer >= 35 then 
			if leveltime % 8 == 0 then
				local ghost = P_SpawnGhostMobj(p.mo)
				ghost.destscale = $*2
			end
		else
			p.mo.colorized = false
		end
		if (p.speed-abs(p.mo.momz)) > 0 then
			if p.mo.state ~= S_NSPECCY_CRAWL then
				p.mo.state = S_NSPECCY_CRAWL
			end
			
			if p.mo.frame % 2 == 0 then
				if not p.dustspawn then
					local dust = P_SpawnMobj(p.mo.x+p.mo.momx+FixedMul(-32*FRACUNIT, cos(p.drawangle)), p.mo.y+p.mo.momy+FixedMul(-32*FRACUNIT, sin(p.drawangle)), p.mo.z, MT_DUST)
					dust.scale = FRACUNIT/2
					local dustangle
					if p.mo.frame % 4 == 0 then
						dustangle = ANGLE_90
					else
						dustangle = ANGLE_270
					end
					P_TeleportMove(dust, p.mo.x+p.mo.momx+FixedMul(4*FRACUNIT, cos(p.drawangle+dustangle)), p.mo.y+p.mo.momy+FixedMul(4*FRACUNIT, sin(p.drawangle+dustangle)), p.mo.z)
					p.dustspawn = true
				end
			else
				p.dustspawn = false
			end
			
			p.pflags = $|PF_STARTDASH
		else
			p.mo.framenum = 0
			p.mo.state = S_PLAY_GLIDE_LANDING 
			p.pflags = $ & ~PF_STARTDASH
		end
		if p.speccyspintap and canSpeccyRoll(p) then
			p.pflags = $|PF_SPINNING
			p.pflags = $ & ~PF_JUMPSTASIS
			if p.speed < skins[p.mo.skin].maxdash-skins[p.mo.skin].mindash*2 then
				P_Thrust(p.mo, p.drawangle, skins[p.mo.skin].maxdash-skins[p.mo.skin].mindash*3)
			else
				p.speed = skins[p.mo.skin].maxdash-skins[p.mo.skin].mindash*2
			end
			S_StartSound(p.mo, sfx_shrpgo, p)
			p.normalspeed = skins[p.mo.skin].normalspeed
			p.mo.state = S_PLAY_ROLL
			p.speccyroll = true
			p.speccycrouch = false
			p.mo.colorized = false
			p.speccyjumptimer = 0
			return
		end
		if (p.cmd.buttons & BT_JUMP) and canSpeccySuperJump(p) then
			if p.speccyjumptimer >= 35 then
				p.speccycrouch = false
				p.pflags = $|PF_JUMPED & ~PF_JUMPSTASIS
				if p.powers[pw_underwater] then
				P_SetObjectMomZ(p.mo, 9*p.jumpfactor, false)
			else
				P_SetObjectMomZ(p.mo, 18*p.jumpfactor, false)
			end
				S_StartSound(p.mo, sfx_cdfm02, p)
				p.normalspeed = skins[p.mo.skin].normalspeed
				p.mo.state = S_PLAY_ROLL
				p.mo.colorized = false
				p.speccyjumptimer = 0
			end
		end
	else
		if p.speccycrouch then
			p.mo.state = S_PLAY_STND
			p.normalspeed = skins[p.mo.skin].normalspeed
			p.pflags = $ & ~PF_JUMPSTASIS
			p.mo.colorized = false
			p.speccyjumptimer = 0
		end
		p.pflags = $ & ~PF_STARTDASH
		p.speccycrouch = false
	end
	
	if p.speccyroll then
		if (p.pflags & PF_JUMPED) or ((p.mo.eflags & MFE_SPRUNG) and p.mo.momz ~= 0) or p.powers[pw_carry] or p.speed < FRACUNIT or P_PlayerInPain(p) then
			p.speccyroll = false
			p.pflags = $ & ~PF_SPINNING
			if P_IsObjectOnGround(p.mo) then
				p.mo.state = S_PLAY_WALK
			end
			return
		end
		p.pflags = $|PF_SPINNING
		p.mo.state = S_PLAY_ROLL
		if p.speccyspintap and P_IsObjectOnGround(p.mo) then
			P_Thrust(p.mo, p.drawangle, skins[p.mo.skin].maxdash-skins[p.mo.skin].mindash*4-skins[p.mo.skin].mindash/3-skins[p.mo.skin].mindash/3)
			if p.powers[pw_underwater] then
				P_SetObjectMomZ(p.mo, 2*p.jumpfactor, false)
			else
				P_SetObjectMomZ(p.mo, 4*p.jumpfactor, false)
			end
		end
	end
	
	if p.speccydive then
		if (p.pflags & PF_JUMPED) or (p.mo.eflags & MFE_SPRUNG) or p.powers[pw_carry] or p.speed < FRACUNIT or P_PlayerInPain(p) then
			p.speccydive = false
			p.pflags = $ & ~PF_SPINNING
			if P_IsObjectOnGround(p.mo) then
				p.mo.state = S_PLAY_WALK
			end
			return
		end
		p.pflags = $|PF_SPINNING
		if P_IsObjectOnGround(p.mo) then
			p.mo.state = S_NSPECCY_SLIDE
			P_SpawnSkidDust(p, p.mo.radius/2, true)
			P_Thrust(p.mo, p.drawangle, -FRACUNIT/8)
		else
			p.mo.state = S_NSPECCY_DIVE
		end
	end
	
	if p.mo.state == S_NSPECCY_SWIM and not p.powers[pw_underwater] then
		p.mo.state = S_PLAY_SPRING
		p.pflags = $|PF_JUMPED
		p.charflags = $ & ~SF_MARIODAMAGE
		if p.mo.momz*P_MobjFlip(p.mo) > P_MobjFlip(p.mo)*FRACUNIT then
			P_SetObjectMomZ(p.mo, 4*p.jumpfactor, true)
		end
	elseif p.mo.state == S_NSPECCY_SWIM_IDLE and not p.powers[pw_underwater] then
		p.mo.state = S_PLAY_FALL
		p.pflags = $|PF_JUMPED
		p.charflags = $ & ~SF_MARIODAMAGE
	elseif p.mo.state == S_NSPECCY_SWIM_IDLE and P_IsObjectOnGround(p.mo) then
		p.mo.state = S_PLAY_STND 
	elseif p.powers[pw_underwater] and not (p.speccycrouch or p.speccycrawl or p.speccyroll or p.speccydive or p.fluffymoonwalking) then
		p.pflags = $ & ~PF_JUMPED
		p.charflags = $|SF_MARIODAMAGE
		if p.mo.state ~= S_NSPECCY_SWIM_IDLE and p.mo.state ~= S_NSPECCY_SWIM and (p.mo.state ~= S_PLAY_STND and not P_IsObjectOnGround(p.mo)) then
			p.mo.state = S_NSPECCY_SWIM_IDLE
		end
	end
	
	if p.speccytwirlcooldown then
		p.speccytwirlcooldown = $ - 1
	end
	
	if p.speccylois then
		p.mo.state = S_NLOIS
	end
end)

addHook("JumpSpecial", function(p)
	if p.mo.health < 1 then return end
	if p.mo.skin ~= "speccy" then return end
	if p.powers[pw_carry] == CR_NIGHTSMODE then return end
	if p.speccydive and P_IsObjectOnGround(p.mo) then
		if p.powers[pw_underwater] then
			P_SetObjectMomZ(p.mo, 3*p.jumpfactor, false)
		else
			P_SetObjectMomZ(p.mo, 6*p.jumpfactor, false)
		end
		S_StartSound(p.mo, sfx_jump, p)
		p.mo.state = S_PLAY_ROLL
		p.speccydive = false
		p.pflags = $|PF_JUMPED
		p.pflags = $ & ~PF_SPINNING
		return true
	elseif canSpeccyTwirl(p) and (p.pflags & PF_JUMPED) and p.speccyjumptap and (not P_PlayerInPain(p)) and (not p.speccytwirlcooldown) and (not p.powers[pw_underwater]) and (not p.powers[pw_carry]) and not (p.speccycrouch or p.wallCling or p.wasclinged or p.speccycrawl or p.speccyroll or p.speccydive or p.fluffymoonwalking) then
		if p.mo.momz*P_MobjFlip(p.mo) < (FRACUNIT+FRACUNIT/2)*P_MobjFlip(p.mo) then
			P_SetObjectMomZ(p.mo, abs(p.mo.momz)+FRACUNIT, true)
		end
		p.mo.state = S_NSPECCY_TWIRL
		p.speccytwirlcooldown = 23
	elseif (p.speccyjumptap) and p.powers[pw_underwater] and (not (p.pflags & PF_SLIDING)) and (not p.powers[pw_carry]) and not (p.speccycrouch or p.wallCling or p.wasclinged or p.speccycrawl or p.speccyroll or p.speccydive or p.fluffymoonwalking) then
		p.mo.state = S_NSPECCY_SWIM
		P_SpawnSkidDust(p, p.mo.radius/2, false)
		if p.mo.momz*P_MobjFlip(p.mo) > (8*FRACUNIT)*P_MobjFlip(p.mo) then return end
		if p.mo.momz*P_MobjFlip(p.mo) > (6*FRACUNIT)*P_MobjFlip(p.mo) then
			P_SetObjectMomZ(p.mo, p.jumpfactor*3/2, true)
		else
			P_SetObjectMomZ(p.mo, p.jumpfactor*6/2, true)
		end
		return true
	end
end)

addHook("SpinSpecial", function(p)
	if p.mo.health < 1 then return end
	if p.mo.skin ~= "speccy" then return end
	if p.powers[pw_carry] == CR_NIGHTSMODE then return end
	if (p.speccyspintap) and p.powers[pw_underwater] and (not (p.pflags & PF_SLIDING)) and (not p.powers[pw_carry]) and not (P_IsObjectOnGround(p.mo) or p.speccycrouch or p.wallCling or p.wasclinged or p.speccycrawl or p.speccyroll or p.speccydive or p.fluffymoonwalking) then
		p.mo.state = S_NSPECCY_SWIM
		if p.mo.momz*P_MobjFlip(p.mo) < (-8*FRACUNIT)*P_MobjFlip(p.mo) then return end
		if p.mo.momz*P_MobjFlip(p.mo) < (-6*FRACUNIT)*P_MobjFlip(p.mo) then
			P_SetObjectMomZ(p.mo, -p.jumpfactor*3/2, true)
		else
			P_SetObjectMomZ(p.mo, -p.jumpfactor*6/2, true)
		end
		P_SpawnSkidDust(p, p.mo.radius/2, false)
		return true
	end
end)

addHook("PlayerThink", function(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	if p.powers[pw_carry] == CR_NIGHTSMODE then return end
	if p.powers[pw_underwater] then return end
	if p.mo.health < 1 then return end
	if not p.speccyspintap then return end
	if P_PlayerInPain(p) then return false end
	if p.speccycrouch or p.speccycrawl or p.speccyroll or p.fluffymoonwalking then return end
	if p.powers[pw_super] == 1 or p.mo.state == S_PLAY_SUPER_TRANS1|S_PLAY_SUPER_TRANS2|S_PLAY_SUPER_TRANS3|S_PLAY_SUPER_TRANS4|S_PLAY_SUPER_TRANS5|S_PLAY_SUPER_TRANS6 then return end
	if p.speed < 8*FRACUNIT then return end
	if p.speccydive then
		if not P_IsObjectOnGround(p.mo) then return end
		P_Thrust(p.mo, p.speccydiveangle, FRACUNIT/17)
		if p.powers[pw_underwater] then
			P_SetObjectMomZ(p.mo, 2*p.jumpfactor, false)
		else
			P_SetObjectMomZ(p.mo, 5*p.jumpfactor, false)
		end
		p.speccydiveangle = p.drawangle
	else
		if p.powers[pw_underwater] then
			P_SetObjectMomZ(p.mo, 3*p.jumpfactor, false)
		else
			P_SetObjectMomZ(p.mo, 6*p.jumpfactor, false)
		end
		p.speccydiveangle = p.drawangle
		p.mo.state = S_NSPECCY_DIVE
		p.pflags = $ & ~PF_JUMPED
		p.pflags = $|PF_SPINNING
		P_InstaThrust(p.mo, p.speccydiveangle, p.speed)
		p.speccydive = true
		S_StartSound(p.mo, sfx_mario6)
	end
end)

/*
 
-- Wall jump? Wall jump.

addHook("MobjMoveBlocked", function(pmo, mo, line)
	if not(pmo and pmo.valid) then return end
	if pmo.skin ~= "speccy" then return end
	if P_IsObjectOnGround(pmo) then return end
	if line and ((pmo.player.pflags & PF_JUMPED) or pmo.player.speccysliding) then
		local angle = R_PointToAngle2(0, 0, line.dx, line.dy)
		pmo.player.cantslide = false
		local sec
		if line.flags & ML_NOCLIMB then return end
		if P_PointOnLineSide(pmo.x, pmo.y, line) == 0
			sec = line.backsector
			pmo.player.wallang = angle+ANGLE_90
		else
			sec = line.frontsector
			pmo.player.wallang = angle-ANGLE_90
		end
		if sec == nil then return end
		if pmo.z+(pmo.height/2) > sec.ceilingheight and sec.ceilingpic == "F_SKY1" then
			pmo.player.cantslide = true
		end
		if (not pmo.player.cantslide) and (pmo.momz < 1) then
			pmo.player.pflags = $|PF_STASIS
			pmo.player.speccysliding = true
		else
			pmo.player.speccysliding = false
			pmo.player.pflags = $ & ~PF_STASIS
			pmo.holdtimer = 0
		end
	end
end, MT_PLAYER)

addHook("PlayerThink", function(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	local pmo = p.mo
	if P_IsObjectOnGround(pmo) then pmo.player.speccysliding = false pmo.holdtimer = 0 return end
	if not pmo.player.speccysliding then return end
	pmo.player.drawangle = pmo.player.wallang
	pmo.momx = 0
	pmo.momy = 0
	pmo.state = S_PLAY_PAIN
	pmo.player.pflags = $ & ~PF_JUMPED
	if pmo.holdtimer > TICRATE then
		if pmo.momz*P_MobjFlip(pmo) <= -2*FRACUNIT
			if pmo.player.powers[pw_underwater] then
				P_SetObjectMomZ(pmo, -FRACUNIT/(10*TICRATE), true)
			else
				P_SetObjectMomZ(pmo, -FRACUNIT/(5*TICRATE), true)
			end
			P_SpawnSkidDust(p, p.mo.radius/2, true)
		end
	elseif pmo.momz*P_MobjFlip(pmo) < 0 then
		P_SetObjectMomZ(pmo, 0, false)
	end
	pmo.holdtimer = $ + 1
	if pmo.player.speccyjumptap then
		P_InstaThrust(pmo, pmo.player.wallang+ANGLE_180, 8*FRACUNIT)
		pmo.state = S_PLAY_SPRING
		pmo.player.drawangle = pmo.player.wallang+ANGLE_180
		if pmo.player.powers[pw_underwater] then
			P_SetObjectMomZ(pmo, 6*pmo.player.jumpfactor, false)
		else
			P_SetObjectMomZ(pmo, 12*pmo.player.jumpfactor, false)
		end
		S_StartSound(p.mo, sfx_cdfm02, p)
		pmo.player.pflags = $|PF_JUMPED
		pmo.player.speccysliding = false
		pmo.holdtimer = 0
	end
end)

*/