-- This Lua contains language, viewer discression is advised.

freeslot("MT_METROIDLARVA", "SKINCOLOR_POWERBEAM")
freeslot("MT_PBSHOT", "MT_SPSHOT", "MT_WVSHOT", "MT_ICSHOT", "MT_PLSHOT")
freeslot("MT_PBCHARGESHOT", "MT_SPCHARGESHOT", "MT_WVCHARGESHOT", "MT_ICCHARGESHOT", "MT_PLCHARGESHOT")
freeslot("MT_CHBM", "MT_SPBM", "MT_WVBM", "MT_ICBM", "MT_PLBM", "MT_BSBL", "MT_SPBL", "MT_SJMP")
freeslot("MT_NRGA", "MT_NRGB", "MT_NRGD", "MT_MTNK", "MT_STNK", "MT_MPKU", "MT_BMPKU", "MT_SPKU")
freeslot("MT_SAMMISSILE", "MT_SAMSUPERMISSILE")
freeslot("sfx_pbsh", "sfx_pbchaf", "sfx_spsh", "sfx_spchsh", "sfx_wvsh", "sfx_wvchsh", "sfx_icsh", "sfx_icchsh", "sfx_plsh", "sfx_plchsh", "sfx_smsh", "sfx_mssh2")


local asciilist = {
	["0"] = 048, 
	["1"] = 049,
	["2"] = 050,
	["3"] = 051,
	["4"] = 052,
	["5"] = 053,
	["6"] = 054,
	["7"] = 055,
	["8"] = 056,
	["9"] = 057,
	["_"] = 095,
	["a"] = 097,
	["b"] = 098,
	["c"] = 099,
	["d"] = 100,
	["e"] = 101,
	["f"] = 102,
	["g"] = 103,
	["h"] = 104,
	["i"] = 105,
	["j"] = 106,
	["k"] = 107,
	["l"] = 108,
	["m"] = 109,
	["n"] = 110,
	["o"] = 111,
	["p"] = 112,
	["q"] = 113,
	["r"] = 114,
	["s"] = 115,
	["t"] = 116,
	["u"] = 117,
	["v"] = 118,
	["w"] = 119,
	["x"] = 120,
	["y"] = 121, 
	["z"] = 122
}

local letterToAscii = function(string)
	local newstring = ""
	for i=1, string.len(string) do
		newstring = $ .. tostring(asciilist[string.sub(string, i, i)])
	end
	return newstring
end

local gfz1_2 = letterToAscii("gfz1_2")
local gfz2_2 = letterToAscii("gfz2_2")
local gfz3_2 = letterToAscii("gfz3_2")
local gfz3_3 = letterToAscii("gfz3_3")
local gfz3_4 = letterToAscii("gfz3_4")
local dsz4_2 = letterToAscii("dsz4_2")
local erz2_2 = letterToAscii("erz2_2")

local agz_2 = letterToAscii("agz_2")
local agz_3 = letterToAscii("agz_3")

rawset(_G, "speccyDialogueList", {
	
	-- Anything within the Zone, and Act arrays are spawn dialogue.
	
	-- GFZ
	
	["Greenflower"] = {
		[1] = {"What happened here? This isn't how", "it looked on the map!", "SPCPAN", 2, 0, nil, nil, nil, gfz1_2},
		[2] = {"These robots are everywhere, I", "wonder who's reponsible.", "SPCDEF", 2, 0, nil, nil, nil, gfz2_2},
		[3] = {"So you're the creator? Why are", "you doing this!?", "SPCPAN", 2, 0, nil, nil, nil, gfz3_2}
	},
	
	-- THZ
	
	["Techno Hill"] = {
		[1] = {"Steampunk? That scientist sure", "does have some interests.", "SPCDEF", 2, 0, nil, nil, nil},
		[2] = {"A factory meant to mass produce stuff,", "interesting.", "SPCDEF", 2, 0, nil, nil, nil}
	},
	
	-- DSZ
	
	["Deep Sea"] = {
		[4] = {"What an unusual habitat, who would", "even live here...?", "SPCDEF", 2, 0, nil, nil, nil},
	},
	
	-- CEZ

	["Castle Eggman"] = {
		[1] = {"The outskirts of a castle, I", "saw that scientist head here.", "SPCDEF", 2, 0, nil, nil, nil},
		[2] = {"Ya know, I wonder how a mad scientist", "makes things like this.", "SPCDEF", 2, 0, nil, nil, nil},
		--[2] = {"I HATE these FUCKING guard IDIOTS,", "they're literally FUCKING EVERYWHERE.", "SPCDEF", 2, 0, nil, nil, nil},
		[3] = {"What's this thing?", "A spinning gauntlet?", "SPCSWE", 2, 0, nil, nil, nil},
	},
	
	-- ACZ
	
	["Arid Canyon"] = {
		[1] = {"*sneeze* Allergies...", "Cacti are not my friends-", "SPCSWE", 2, 0, nil, nil, nil},
		[2] = {"Early mornings aren't fun either...", nil, "SPCWHA", 2, 0, nil, nil, nil},
		[3] = {"Huh, who's this?", "He doesn't seem friendly...", "SPCSWE", 2, 0, nil, nil, nil},
		[4] = {"I don't like the atmosphere here...", nil, "SPCDEF", 2, 0, nil, nil, nil}
	},

	-- RVZ
	
	["Red Volcano"] = {
		[1] = {"It sure is.. burning up here...", nil, "SPCSWE", 2, 0, nil, nil, nil},
	},

	-- ERZ

	["Egg Rock"] = {
		[1] = {"I've made it to the base of operations,", "now to shut it down!", "SPCDEF", 2, 0, nil, nil, nil},
		[2] = {"It's deeper than I thought, that", "scientist must keep a lot.", "SPCDEF", 2, 0, nil, nil, nil, erz2_2},
	},
	
	-- BCZ
	
	["Black Core"] = {
		[1] = {"I need to get out of here...", "QUICK!!", "SPCPAN", 2, 0, nil, nil, nil},
		[2] = {"So this is that scientist's greatest", "creation...?", "SPCWHA", 2, 0, nil, nil, nil},
		[3] = {"!!", nil, "SPCPAN", 2, 0, nil, nil, nil},
	},
	
	["Aerial Garden"] = {
		[0] = {"This is the story of a kitsune named", "Speccy. Speccy is an explorer, who-", "SPCDEF", 1, 0, nil, nil, nil, agz_2},
	},
	
	["bee"] = {"Bee.", nil, "SPCDEF", 1, 0, nil, nil, nil},
	
	[agz_2] = {"found her way to the heavens, Aerial", "Garden. Destined to reach the end,", "SPCDEF", 1, 0, nil, nil, nil, agz_3},
	[agz_3] = {"she begins explore the gardens.", nil, "SPCDEF", 1, 0, nil, nil, nil},
	
	[gfz1_2] = {"I guess it's up to me to find out...", nil, "SPCDEF", 2, 0, nil, nil, nil},
	[gfz2_2] = {"I'm sure I'll find out soon,", "their creator can't be far.", "SPCDEF", 2, 0, nil, nil, nil},
	[gfz3_2] = {"To take over Mobius of course!", "Why else would I?", "EGGDEF", 2, 0, nil, nil, nil, gfz3_3},
	[gfz3_3] = {"I won't let you!", nil, "SPCDEF", 2, 0, nil, nil, nil, gfz3_4},
	[gfz3_4] = {"Try if you can...!", nil, "EGGDEF", 2, 0, nil, nil, nil},
	[dsz4_2] = {"AAE-", nil, "SPCPAN", 2, 0, nil, nil, nil},
	[erz2_2] = {"I must make my way through though.", nil, "SPCDEF", 2, 0, nil, nil, nil}
})

-- oh my fucking god speccy is samus

/*rawset(_G, "YouAreSamus", function(s) --Checks for either skin.
	if s.skin == "samus"
	or s.skin == "basesamus"
	or s.skin == "speccy"
	return true
	else
	return false
	end
end)*/

-- But what if she had something of some sort-

local speccyBeams = {
	{3, MT_PBSHOT, nil, MT_PBCHARGESHOT, 32, sfx_pbsh, sfx_pbchaf, SKINCOLOR_POWERBEAM},
	{8, MT_SPSHOT, 1, MT_SPCHARGESHOT, 24, sfx_spsh, sfx_spchsh, SKINCOLOR_GREEN},
	{14, MT_WVSHOT, 2, MT_WVCHARGESHOT, 32, sfx_wvsh, sfx_wvchsh, SKINCOLOR_MAGENTA},
	{20, MT_ICSHOT, nil, MT_ICCHARGESHOT, 30, sfx_icchsh, sfx_icsh, SKINCOLOR_SKY},
	{13, MT_PLSHOT, nil, MT_PLCHARGESHOT, 32, sfx_plsh, sfx_plchsh, SKINCOLOR_RED}
}

addHook("PlayerSpawn", function(p)
	if not (p.mo and p.mo.valid) then return end
	if (p.mo.skin ~= "speccy") then return end
	if (skins["samus"] == nil) then return end
	if (p.mo.health < 1) then return end
	if G_GametypeHasSpectators() and leveltime < 5 then p.speccysamus = nil end
	p.mo.missiletrns = 0
	p.mo.supermissiletrns = 0
	if p.powers[pw_carry] == CR_NIGHTSMODE then return end
end)

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid) then return end
	if (p.mo.skin ~= "speccy") then return end
	if (skins["samus"] == nil) then return end
	if (p.mo.health < 1) then return end
	if p.powers[pw_carry] == CR_NIGHTSMODE then return end
	
	if p.speccysamus == nil then
		p.speccysamus = {}
		p.speccysamus.beam = 1
		p.speccysamus.beams = {1,0,0,0,0}
		p.speccysamus.allbeams = speccyBeams -- i am lazy
		p.speccysamus.fire = 0
		p.speccysamus.nfire = 0
		if G_GametypeHasSpectators() then
			p.speccysamus.maxmissiles = 5
			p.speccysamus.missiles = 5
			p.speccysamus.maxsmissiles = 0
			p.speccysamus.smissiles = 0
		else
			p.speccysamus.maxmissiles = 0
			p.speccysamus.missiles = 0
			p.speccysamus.maxsmissiles = 0
			p.speccysamus.smissiles = 0
		end
		p.speccysamus.lockon = 0
		p.speccysamus.cooldown = 0
		p.speccysamus.charge = 0
		p.speccysamus.ncharge = 0
		if G_GametypeHasSpectators() then
			p.speccysamus.chargebeam = true
		else
			p.speccysamus.chargebeam = false
		end
		p.speccysamus.boostball = false
		p.speccysamus.hijump = false
		p.speccysamus.spacejump = false
	end
	
	if not (p.cmd.buttons & BT_CUSTOM1) then
		p.speccysamus.lockon = 0
	else
		p.speccysamus.lockon = $ + 1
	end
	
	p.ringweapons = 0
	p.ammoremoval = 9999
	if hud.enabled("weaponrings")
		hud.disable("weaponrings")
	end
	
	if (p.cmd.buttons & BT_WEAPONPREV) then
		p.speccysamus.beam = $ - 1
		p.speccysamus.charge = 0
		for i=p.speccysamus.beam, 1, -1 do
			if p.speccysamus.beams[p.speccysamus.beam] == 0 then
				p.speccysamus.beam = $-1
				if p.speccysamus.beam < 1 then 
					p.speccysamus.beam = 1
				end
			else
				return
			end
		end
	elseif (p.cmd.buttons & BT_WEAPONNEXT) then
		p.speccysamus.beam = $ + 1
		p.speccysamus.charge = 0
		for i=p.speccysamus.beam, 5 do
			if p.speccysamus.beams[p.speccysamus.beam] == 0 then
				p.speccysamus.beam = $+1
				if p.speccysamus.beam > 5 then 
					if p.speccysamus.beams[5] > 0 then
						p.speccysamus.beam = 5
					else
						p.speccysamus.beam = 1
					end
				end
			else
				continue
			end
		end
	end
	
	if (p.cmd.buttons & BT_WEAPONMASK) then
		p.speccysamus.beam = (p.cmd.buttons & BT_WEAPONMASK)
		if p.speccysamus.beam > p.speccysamus.oldbeam then
			for i=p.speccysamus.beam, 5 do
				if p.speccysamus.beams[p.speccysamus.beam] == 0 then
					p.speccysamus.beam = $+1
					if p.speccysamus.beam > 5 then 
						if p.speccysamus.beams[5] > 0 then
							p.speccysamus.beam = 5
						else
							p.speccysamus.beam = 1
						end
					end
				else
					continue
				end
			end
		elseif p.speccysamus.beam < p.speccysamus.oldbeam then
			for i=p.speccysamus.beam, 1, -1 do
				if p.speccysamus.beams[p.speccysamus.beam] == 0 then
					p.speccysamus.beam = $-1
					if p.speccysamus.beam < 1 then 
						p.speccysamus.beam = 1
					end
				else
					return
				end
			end
		end
	end
	p.speccysamus.oldbeam = p.speccysamus.beam
	
	if p.speccysamus.beam > 5 then 
		p.speccysamus.beam = 5
	elseif p.speccysamus.beam < 1 then 
		p.speccysamus.beam = 1
	end
	
	if p.speccysamus.missiles > p.speccysamus.maxmissiles then
		p.speccysamus.missiles = p.speccysamus.maxmissiles
	end
	
	if p.speccysamus.smissiles > p.speccysamus.maxsmissiles then
		p.speccysamus.smissiles = p.speccysamus.maxsmissiles
	end
	
	local s = p.mo
	
	if not p.speccysamus.cooldown then
		if not (p.speccydive or p.speccycrouch or p.speccyroll) and (p.speccysamus.fire or p.speccysamus.nfire) then
			if P_IsObjectOnGround(p.mo) then
				p.mo.state = S_PLAY_FIRE
			else
				p.mo.state = S_NSPECCY_FIRE_AIR
			end
			if p.speccysamus.fire == 1 then
				SamusBeamFire(p.mo, speccyBeams[p.speccysamus.beam][2], speccyBeams[p.speccysamus.beam][3])
				p.speccysamus.cooldown = speccyBeams[p.speccysamus.beam][1]
				S_StartSound(p.mo, speccyBeams[p.speccysamus.beam][6])
			elseif p.speccysamus.fire and p.speccysamus.charge < speccyBeams[p.speccysamus.beam][5] and p.speccysamus.chargebeam and not p.speccysamus.nfire then
				p.speccysamus.charge = $ + 1
				if (p.speccysamus.charge == 1)
					S_StartSound(p.mo, sfx_pbcha)
				end
			elseif p.speccysamus.chargebeam and (p.cmd.buttons & BT_ATTACK) and not p.speccysamus.nfire then
				p.speccysamus.charge = $ + 1
				if (p.speccysamus.charge % 50 == 0)
					S_StartSound(p.mo, sfx_pbchao)
				end			
			elseif p.speccysamus.chargebeam and not p.speccysamus.nfire and not (p.cmd.buttons & BT_ATTACK) then
				SamusBeamFire(p.mo, speccyBeams[p.speccysamus.beam][4], speccyBeams[p.speccysamus.beam][3])
				S_StartSound(p.mo, speccyBeams[p.speccysamus.beam][7])
				p.speccysamus.charge = 0
			end
			if p.speccysamus.nfire == 1 and p.speccysamus.missiles then
				SamusBeamFire(p.mo, MT_SAMMISSILE)
				p.speccysamus.missiles = $-1
				S_StartSound(p.mo, sfx_mssh2)
				S_StartSound(p.mo, sfx_mssh2)
				p.speccysamus.cooldown = 14
			elseif p.speccysamus.smissiles and p.speccysamus.nfire and p.speccysamus.ncharge < 32 and not p.speccysamus.fire then
				p.speccysamus.ncharge = $+1
				if p.speccysamus.ncharge == 31 then
					S_StartSound(p.mo, sfx_mread)
				end
			elseif p.speccysamus.smissiles and not p.speccysamus.fire and not (p.cmd.buttons & BT_FIRENORMAL) then
				SamusBeamFire(p.mo, MT_SAMSUPERMISSILE)
				p.speccysamus.smissiles = $-1
				A_samquake(p.mo, 10*FRACUNIT, 5, 3500*FRACUNIT)
				S_StartSound(p.mo, sfx_smsh)
				S_StartSound(p.mo, sfx_smsh)
				p.speccysamus.ncharge = 0
				p.speccysamus.cooldown = 20
			end
		end
	else
		p.speccysamus.charge = 0
		p.speccysamus.ncharge = 0
		p.speccysamus.cooldown = $ - 1
	end
	
	if not (p.cmd.buttons & BT_ATTACK) then
		p.speccysamus.charge = 0
		p.speccysamus.fire = 0
		S_StopSoundByID(s, sfx_pbcha)
		S_StopSoundByID(s, sfx_pbchao)
	else
		p.speccysamus.fire = $ + 1
	end
	
	if not (p.cmd.buttons & BT_FIRENORMAL) then
		p.speccysamus.ncharge = 0
		p.speccysamus.nfire = 0
	else
		p.speccysamus.nfire = $ + 1
	end
	
	if p.sam_lockonpower == nil
			p.sam_lockonpower = 1
			end
			if p.sam_lockontoggle == nil
			p.sam_lockontoggle = true
			end
	
	if p.sam_lockonpower and not (p.sam_lockontoggle and s.sam_automob and s.sam_automob.valid)
				and ( (((p.cmd.buttons & BT_CUSTOM1) and not (p.sams_c1cd and p.sams_c1cd > 1)) and p.sam_lockonpower == 1))
					if not p.powers[pw_nocontrol] and not p.exiting and not p.sam_screwattacking and not p.beampain
					and not p.sam_shinesparkfly and not s.crystalflashanim and not p.sam_intoship
						s.sam_lockseek = 3
						s.sam_lockchosen = nil
						s.sam_automob = nil
						s.sam_lockedon = false
						for d = 1,12
						s.sam_lock = P_SpawnMobj(s.x+FixedMul((600*FRACUNIT)*d, cos(s.angle)),s.y+FixedMul((600*FRACUNIT)*d, sin(s.angle)), s.z, MT_SAMUSLOCKSEEK)
							if s.sam_lock and s.sam_lock.valid
							s.sam_lock.tics = 1
							s.sam_lock.target = s
							s.sam_lock.flags2 = $|MF2_DONTDRAW
							end					
						end
					end
				elseif s.sam_lockseek
				s.sam_lockseek = $-1
					if s.sam_lockchosen
						if s.sam_lockchosen.valid and P_CheckSight(s, s.sam_lockchosen)
							s.sam_automob = s.sam_lockchosen
							s.sam_lockchosen = nil
							s.sam_lockedon = true
							s.sam_lockseek = 3
							s.sam_sighttime = 0
							s.sam_faillock = false
							SamusTutorial(s, "lockon", true)
							if p.sam_lockontoggle
								p.sams_c1cd = 4
								p.sams_c3cd = true
							end
						end
					end
					--Here's our target, let's do behaviour.
					if s.sam_automob and s.sam_automob.valid
					local t = s.sam_automob	
					
						if t.player
						t.sam_automobed = 3
						end
						
						--Cursor
						if not (p.automobf and p.automobf.valid)
						p.automobf = P_SpawnMobj(t.x, t.y, t.z+t.height/6, MT_SAMUSLOCKGFX)
						p.automobf.scale = (t.height/24)*3
						p.automobf.scalespeed = (t.height/300)*4
						p.automobf.color = SKINCOLOR_SKY
						p.automobf.colorized = true
						S_StartSound(s, sfx_samtm8)
							if s.sam_automob.player
							S_StartSound(s, sfx_samtm8, s.sam_automob.player)
							end
						end
						
						if (p.automobf and p.automobf.valid)
						p.automobf.sprite = SPR_MPR1
							if p.automobf.scale != t.height/24
							p.automobf.frame = (Z+1)|TR_TRANS60|FF_FULLBRIGHT
							p.automobf.destscale = t.height/24
							else
							p.automobf.frame = (Z+1)|TR_TRANS40|FF_FULLBRIGHT
							end
						p.automobf.rollangle = $+ANG20
						p.automobf.tics = 3
						P_TeleportMove(p.automobf, t.x, t.y, t.z)
						s.sam_beamroll = 0
						end
						
					--Aiming adjustment.
						if p.sam_lockontoggle
							if ( (((p.cmd.buttons & BT_CUSTOM1) and not (p.sams_c1cd and p.sams_c1cd > 2)) and p.sam_lockonpower == 1))
							s.sam_faillock = true
							else
							s.sam_lockseek = 3
							end
						else
							if ((p.cmd.buttons & BT_CUSTOM1) and p.sam_lockonpower == 1)							s.sam_lockseek = 3
							end
						end
						
						--Vertical aiming

						p.aiming = R_PointToAngle2(0, 0, R_PointToDist2(s.x, s.y, t.x, t.y), ((t.z+(t.height/5)) - s.z)	)					
						
						
						--The higher 2020 is, the more the aim vertically overcompensates. 
						if t.superbrak
						p.aiming = $+1500*FRACUNIT
						end
						
						if p.aiming > 11500*FRACUNIT or p.aiming < -11500*FRACUNIT
						or p.sam_screwattacking 
						s.sam_faillock = true
						else
						
							if (p.pflags & PF_ANALOGMODE)
							and not (p.pflags & PF_DIRECTIONCHAR)
								if not p.sam_forcedirectcharoff --old analogmode fix. console: directionchar 0, configanalog 1
							//	p.pflags = $ & ~PF_DIRECTIONCHAR & ~PF_ANALOGMODE
								COM_BufInsertText(p, "configanalog 1; directionchar 1")
								end
								p.sam_forcedirectcharoff = 2
							end
							if p.sam_forcedirectcharoff --Refresh infinitely.
							p.sam_forcedirectcharoff = 2
							end							
							s.angle = R_PointToAngle2(s.x, s.y, t.x, t.y)
							p.drawangle = s.angle
						end
						
					--Fail conditions	
						if (leveltime % 5 == 0) --periodic checks.
						local distcheck = FixedHypot(t.x-s.x, t.y-s.y)
							--Don't stay out of sight too long.
							if not P_CheckSight(s,t)
							s.sam_sighttime = s.sam_sighttime and $+2 or 2
							elseif s.sam_sighttime
							s.sam_sighttime = $-1
							end
							
							if (distcheck < 40*FRACUNIT or distcheck > 9000*FRACUNIT)
							or (s.state == S_PLAY_PAIN) and not (p.pflags & PF_SLIDING)
							or p.powers[pw_nocontrol] or p.sammorphed
							or p.sam_shinesparkfly or s.crystalflashanim
							or s.sam_wavestunned or s.sam_systemreboot
							or s.sam_sighttime and s.sam_sighttime >= 17
							or ((t.flags & MF_MONITOR) and (t.flags2 & MF2_DONTDRAW))
							or (t.flags2 & MF2_FRET) and (t.flags & MF_BOSS) and not t.superbrak
							s.sam_faillock = true
							end
						end
					end
					if not s.sam_lockseek
					or s.sam_faillock
					or s.sam_automob and not s.sam_automob.valid
					or s.sam_automob and not s.sam_automob.health
						if s.sam_automob
						p.aiming = 0
						s.sam_automob = nil
						end
						if (p.automobf and p.automobf.valid)
						p.automobf.color = SKINCOLOR_SILVER
						p.automobf.destscale = $*10
						p.automobf.scalespeed = $*2
						p.automobf.tics = 8
						p.automobf.cancellock = true
						p.automobf.frame = (Z+1)|TR_TRANS80|FF_FULLBRIGHT
						p.automobf = nil
						end
					s.sam_faillock = false
					s.sam_lockedon = false
					s.sam_lockseek = 0
					s.sam_sighttime = 0
					s.sam_lockclosest = nil
					s.sam_lockchosen = nil
					end
				end
	
	if (gametype ~= GT_COOP) then return end
	if speccyDialogueList[mapheaderinfo[gamemap].lvlttl] ~= nil and (leveltime == 70) then
		local dialogue = speccyDialogueList[mapheaderinfo[gamemap].lvlttl][mapheaderinfo[gamemap].actnum]
		p.mo.samusforcetext = true
		SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], dialogue[4], 0, dialogue[5], dialogue[6], dialogue[7], dialogue[8])
		if dialogue[9] ~= nil then
			p.mo.samusdialogue.customnextbox = dialogue[9]
		end
	end
		
	if p.goodbyedialogue then
		p.mo.samusforcetext = false
	end
	
	if p.mo.samusdialogue and p.mo.samusdialogue.customnextboxready then
		p.mo.samusdialogue.active = false
		if speccyDialogueList[p.mo.samusdialogue.customnextbox] ~= nil then
			local dialogue = speccyDialogueList[p.mo.samusdialogue.customnextbox]
			SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], dialogue[4], 0, dialogue[5], dialogue[6], dialogue[7], dialogue[8])
			if dialogue[9] ~= nil then
				p.mo.samusdialogue.customnextbox = dialogue[9]
			else
				p.mo.samusdialogue.customnextbox = 0
			end
		end
	end
end)

addHook("MobjThinker", function(redring)
	if (skins["samus"] == nil) then return end
	if redring.target.type ~= MT_PLAYER then return end
	if redring.target.skin == "speccy" then
		redring.target.player.rings = $+1
		P_RemoveMobj(redring)
	end
end, MT_REDRING)

addHook("MobjThinker", function(redring)
	if (skins["samus"] == nil) then return end
	if not redring.target then return end
	if redring.target.type ~= MT_PLAYER then return end
	if redring.target.skin == "speccy" then
		P_RemoveMobj(redring)
	end
end, MT_THROWNINFINITY)

addHook("MobjThinker", function(bee)
	if (skins["samus"] == nil) then return end
	if (gametype ~= GT_COOP) then return end
	if not (bee and bee.valid) then return end
	P_LookForPlayers(bee, 128*FRACUNIT, true, true)
	if bee.tracer.type ~= MT_PLAYER then return end
	local pmo = bee.tracer
	if not (pmo and pmo.valid) then return end
	if pmo.samusdialogue.customnextbox then return end
	if pmo.samusdialogue.active then return end
	local dialogue = speccyDialogueList["bee"]
	pmo.samusforcetext = true
	SamusDialogue(pmo, dialogue[1], dialogue[2], dialogue[3], dialogue[4], 0, dialogue[5], dialogue[6], dialogue[7], dialogue[8])
	pmo.samusdialogue.customnextbox = 0
	bee.tracer = nil
end, MT_BUMBLEBORE)

/*addHook("MobjDamage", function(pmo)
	pmo.samusforcetext = true
	SamusDialogue(pmo, "OW, WHAT THE FU- AAAAAGGGHH!!!", "FUCK YOU DAMN GUARDS!!", "SPCPAN", 2, 0, 0)
end, MT_PLAYER)*/

addHook("MobjDeath", function(s, i, so)
	if not (so and so.player) --Don't get hurt by non-player things.
	return true
	end
	if not (so and so.valid) then return end
	if (so.skin ~= "speccy") then return end
	if (skins["samus"] == nil) then return end
	if (gametype ~= GT_COOP) then return end
	so.samusforcetext = true
	SamusDialogue(so, "That wasn't much of a fight...", nil, "SPCWHA", 2, 0, 105-17)
	so.samusdialogue.customnextbox = dsz4_2
end, MT_METROIDLARVA)

-- Pickups at the bottom.

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "speccy"
		if s
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height+5*FRACUNIT)
				return nil
			end
			if v.player.fusionmode
				v.player.rings = $+5
			else
				v.player.rings = $+10
			end
			if v.player.buffbottomtier and G_GametypeHasSpectators()
				v.player.rings = $+20
			end
			NewSamPickup(v, "NRGAB0", 65555, nil, nil, TR_TRANS40)
			S_StartSound(v, sfx_nrga)
			s.state = S_NULL
			return false
		end
	end
end, MT_NRGA)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "speccy"
		if s
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height+5*FRACUNIT)
				return nil
			end
			if v.player.fusionmode
				v.player.rings = $+10
			elseif v.player.sam_hyperbeam and G_GametypeHasSpectators()
				v.player.rings = $+15
			else
				v.player.rings = $+25
			end
			if v.player.buffbottomtier and G_GametypeHasSpectators()
				v.player.rings = $+35
			end
			NewSamPickup(v, "NRGBC0", 65555, nil, nil, TR_TRANS30)	
			S_StartSound(v, sfx_nrga)
			s.state = S_NULL
			return false
		end
	end
end, MT_NRGB)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "speccy"
		if (v.z > s.z+s.height)
		or (s.z > v.z+v.height+5*FRACUNIT)
			return nil
		end
		NewSamPickup(v, "NRGDB0", FRACUNIT, nil, SKINCOLOR_SUPERGOLD4, TR_TRANS30)
		if v.player.fusionmode
			v.player.rings = $+25
		elseif v.player.sam_hyperbeam and G_GametypeHasSpectators()
			v.player.rings = $+30
		else
			v.player.rings = $+50
		end
		if v.player.buffbottomtier and G_GametypeHasSpectators() and not v.player.sam_hyperbeam
			v.player.rings = $+75
		end
			
		S_StartSound(v, sfx_nrga)
		s.state = S_NULL
		return false
	end
end, MT_NRGD)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "speccy"
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height+8*FRACUNIT)
			return nil
			end
			if not v.player.fusionmode
			v.player.speccysamus.missiles = $+2*v.player.sam_ammodigitizer
			else
			v.player.speccysamus.missiles = $+1*v.player.sam_ammodigitizer
			end
			if v.player.buffbottomtier and G_GametypeHasSpectators()
			v.player.speccysamus.missiles = $+1*v.player.sam_ammodigitizer
			end
			
			NewSamPickup(v, "MPKUA0", 37555)
			S_StartSound(v, sfx_mpku)
			s.state = S_NULL
			return false
	end
end, MT_MPKU)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "speccy"
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height+8*FRACUNIT)
			return nil
			end
			if v.player.fusionmode
			v.player.speccysamus.missiles = $+3*v.player.sam_ammodigitizer
			else
			v.player.speccysamus.missiles = $+5*v.player.sam_ammodigitizer
			end
			if v.player.buffbottomtier and G_GametypeHasSpectators()
			v.player.speccysamus.missiles = $+3*v.player.sam_ammodigitizer
			end
			
			NewSamPickup(v, "MPKUC0", 47555)	
			S_StartSound(v, sfx_mpku)
			s.state = S_NULL
			return false
	end
end, MT_BMPKU)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "speccy"
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height+8*FRACUNIT)
			return nil
			end
			if (v.player.speccysamus.smissiles < v.player.speccysamus.maxsmissiles)
			v.player.speccysamus.smissiles = $+1*v.player.sam_ammodigitizer
			else
			v.player.speccysamus.smissiles = $+2*v.player.sam_ammodigitizer
			end
			if v.player.buffbottomtier and G_GametypeHasSpectators() and v.player.speccysamus.maxsmissiles
			v.player.speccysamus.smissiles = $+1*v.player.sam_ammodigitizer
			end
			
			NewSamPickup(v, "SPKUA0", 47555)	
			S_StartSound(v, sfx_mpku)
			s.state = S_NULL
			return false
	end
end, MT_SPKU)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "speccy"
		if s
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height+5)
			return nil
			end
			if v.player.sammissilesmax != nil
				if v.player.sammissilesmax
				P_SamFP(v.player, PAL_MIXUP, 7)
				S_StartSound(v, sfx_mtnk)
				else
				P_SamFP(v.player, PAL_MIXUP, 9)
				CONS_Printf(v.player, "You've obtained \x84Missiles!\x80 Press FIRE to shoot them, but watch your ammo!")
				S_StartSound(v, sfx_spwup)
				end
			SamusTutorial(v, "missiles")
			v.player.speccysamus.maxmissiles = $+5
				if not v.player.fusionmode
				v.player.speccysamus.missiles = $+5
				end
			NewSamPickup(v, "MTNKD0", 55355, nil, nil)
			ItemGetPopup(v.player, 80, SKINCOLOR_CRIMSON, "Missiles", 70000)
			end
		s.state = S_NULL
		return false
		end
	end
end, MT_MTNK)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "speccy"
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height)
			return nil
			end
			if v.player.nosuperpowert and G_GametypeHasSpectators()
			v.player.speccysamus.missiles = $+3
			S_StartSound(v, sfx_mpku)
					if not v.player.samhudmessagetime
					v.player.samhudmessagetime = 50
					v.player.samhudmessage1 = "\x85"+"Super Missiles tanks are currently set to ammo."
					v.player.samhudmessage2 = nil
					end
				s.state = S_NULL
				return false
			elseif v.player.speccysamus.maxsmissiles
			P_SamFP(v.player, PAL_MIXUP, 7)
			S_StartSound(v, sfx_mtnk)
			else
			P_SamFP(v.player, PAL_MIXUP, 9)
			CONS_Printf(v.player, "You've obtained \x84Super Missiles!\x80 Hold FIRE until it clicks, then release!")
			S_StartSound(v, sfx_spwup)
			end
		SamusTutorial(v, "supermissiles")	
		v.player.speccysamus.maxsmissiles = $+2
			if not v.player.fusionmode
			v.player.speccysamus.smissiles = $+2
			end
		NewSamPickup(v, "STNKD0", 55355)	
		ItemGetPopup(v.player, 80, SKINCOLOR_CRIMSON, "Super Missiles", 105355)
		s.state = S_NULL
		return false
	end
end, MT_STNK)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "speccy"
		if s
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height)
			return nil
			end
			if not v.player.speccysamus.chargebeam
			P_SamFP(v.player, PAL_MIXUP, 9)
			S_StartSound(v, sfx_spwup)
			CONS_Printf(v.player, "You've obtained the\x85 Charge Beam!\x80 Hold C2/NormalFire to charge your arm cannon!")
			v.player.speccysamus.chargebeam = true
			v.player.samitemgettimer = 80
			v.player.samitemcolor = SKINCOLOR_BLACK
			v.player.samitemgetname = "Charge Beam"
			v.player.samitemscale = 88000
			end
		NewSamPickup(v, "CHBMA0", 83355)
		s.state = S_NULL
		return false
		end
	end
end, MT_CHBM)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "speccy"
		if s
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height)
			return nil
			end
			if v.player.speccysamus.beams[2] ~= 1 then
			P_SamFP(v.player, PAL_MIXUP, 9)
			S_StartSound(v, sfx_spwup)
			CONS_Printf(v.player, "You've obtained the \x85Spazer Beam!\x80 The beam spreads when fired.")
			v.player.speccysamus.beams[2] = 1
			v.player.samitemgettimer = 80
			v.player.samitemcolor = SKINCOLOR_BLACK
			v.player.samitemgetname = "Spazer Beam"
			v.player.samitemscale = 88000
			end
		NewSamPickup(v, "SPBMA0", 40355)	
		s.state = S_NULL
		return false
		end
	end
end, MT_SPBM)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "speccy"
		if s
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height)
			return nil
			end
			if v.player.speccysamus.beams[3] ~= 1 then
			P_SamFP(v.player, PAL_MIXUP, 9)
			S_StartSound(v, sfx_spwup)
			CONS_Printf(v.player, "You've obtained the \x85Wave Beam!\x80 This tricky beam bounces and paralyzes foes.")
			v.player.speccysamus.beams[3] = 1		
			v.player.samitemgettimer = 80
			v.player.samitemcolor = SKINCOLOR_BLACK
			v.player.samitemgetname = "Wave Beam"
			v.player.samitemscale = 83000
			end
		NewSamPickup(v, "WVBMA0", 40355)	
		s.state = S_NULL
		return false
		end
	end
end, MT_WVBM)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "speccy"
		if s
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height)
			return nil
			end
			if v.player.speccysamus.beams[4] ~= 1 then
			P_SamFP(v.player, PAL_MIXUP, 9)
			S_StartSound(v, sfx_spwup)
			CONS_Printf(v.player, "You've obtained the \x85Ice Beam!\x80 The beam explodes upon impact and can freeze foes.")
			v.player.speccysamus.beams[4] = 1
			v.player.samitemgettimer = 80
			v.player.samitemcolor = SKINCOLOR_BLACK
			v.player.samitemgetname = "Ice Beam"
			v.player.samitemscale = 81000
			end
		NewSamPickup(v, "ICBMA0", 40355)	
		s.state = S_NULL
		return false
		end
	end
end, MT_ICBM)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "speccy"
		if s
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height)
			return nil
			end
			if v.player.speccysamus.beams[5] ~= 1 then
			P_SamFP(v.player, PAL_MIXUP, 9)
			S_StartSound(v, sfx_spwup)
			CONS_Printf(v.player, "You've obtained the \x85Plasma Beam!\x80 This powerful mid-range beam pierces the enemy.")
			v.player.speccysamus.beams[5] = 1
			v.player.samitemgettimer = 80
			v.player.samitemcolor = SKINCOLOR_BLACK
			v.player.samitemgetname = "Plasma Beam"
			v.player.samitemscale = 86000
			end
		NewSamPickup(v, "PLBMA0", 40355)	
		s.state = S_NULL
		return false
		end
	end
end, MT_PLBM)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "speccy"
		if s
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height)
			return nil
			end
			if not v.player.speccysamus.boostball
			P_SamFP(v.player, PAL_MIXUP, 9)
			S_StartSound(v, sfx_spwup)
			CONS_Printf(v.player, "You've learned how to\x83 Roll!\x80 Hold Crouch, then press Spin to roll!")
			v.player.speccysamus.boostball = true
			ItemGetPopup(v.player, 80, SKINCOLOR_GREEN, "Roll", 88000)
			elseif (gametype == GT_COOP) and (netgame or splitscreen) and not (v.player.coopboxrespawn and v.player.coopboxrespawn == 2)
			return false
			else
			S_StartSound(v, sfx_mpku)
			v.player.speccysamus.missiles = $+4
			end
		NewSamPickup(v, "BSBLA0", 56355)	
		s.state = S_NULL
		return false
		end
	end
end, MT_BSBL)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "speccy"
		if s
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height)
			return nil
			end
			if not v.player.speccysamus.hijump
			P_SamFP(v.player, PAL_MIXUP, 9)
			S_StartSound(v, sfx_spwup)
			CONS_Printf(v.player, "You've learned the \x83Super Jump!\x80 Hold crouch to charge it, and press jump to release!")
			v.player.speccysamus.hijump = true
			ItemGetPopup(v.player, 80, SKINCOLOR_GREEN, "Super Jump", 70000)
			elseif (gametype == GT_COOP) and (netgame or splitscreen) and not (v.player.coopboxrespawn and v.player.coopboxrespawn == 2)
			return false
			end
		NewSamPickup(v, "SPBLB0", 76355)	
		s.state = S_NULL
		return false
		end
	end
end, MT_SPBL)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "speccy"
		if s
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height)
			return nil
			end
			if not v.player.speccysamus.spacejump
			P_SamFP(v.player, PAL_MIXUP, 9)
			S_StartSound(v, sfx_spwup)
			CONS_Printf(v.player, "You've learned the \x83Twirl!\x80 Press jump in midair to halt your descent!")
			v.player.speccysamus.spacejump = true
			ItemGetPopup(v.player, 80, SKINCOLOR_GREEN, "Twirl", 81000)
			elseif (gametype == GT_COOP) and (netgame or splitscreen) and not (v.player.coopboxrespawn and v.player.coopboxrespawn == 2)
			return false
			else
			S_StartSound(v, sfx_mpku)
			v.player.speccysamus.missiles = $+1
			v.player.speccysamus.smissiles = $+1
			end
		NewSamPickup(v, "SJMPA0", 35355)	
		s.state = S_NULL
		return false
		end
	end
end, MT_SJMP)